;#########################################################################
;        Assembler directives

.386
.model flat,stdcall
option casemap:none

;#########################################################################
;        Include file

include AddManifest.inc

.code

;#########################################################################
;        Common AddIn Procedures

align DWORD
DllEntry        proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
    .if reason == DLL_PROCESS_ATTACH
        push hInst
        pop hInstance
    .endif
    push TRUE
    pop eax
    ret
DllEntry Endp

align DWORD
InstallDll      proc uses ebx esi edi hWin:DWORD, fOpt:DWORD
; Export this proc (it is autoexported if MakeDef is enabled with option 2)
    
    mov ebx,hWin

    ;Get pointer to handles struct
    invoke SendMessage,ebx,AIM_GETHANDLES,0,0;    
    mov lpHandles,eax

    ;Get pointer to proc struct
    invoke SendMessage,ebx,AIM_GETPROCS,0,0
    mov lpProc,eax

    ;Get pointer to data struct
    invoke SendMessage,ebx,AIM_GETDATA,0,0    
    mov lpData,eax

    ; If Option (fOpt) = 0 then exit
    mov eax,fOpt
    mov fOptions,eax
    and eax,1   ;Enabled?
    .if ! zero?
        ; Allocate a new menu id
        invoke SendMessage,ebx,AIM_GETMENUID,0,0
        mov IDAddIn,eax
        mov eax,lpData
        mov edx,lpHandles
        mov ecx,4
        .if [eax].ADDINDATA.fMaximized != FALSE
            inc ecx
        .endif
        invoke GetSubMenu,[edx].ADDINHANDLES.hMenu,ecx
        mov hSubMenu,eax
        mov ebx,eax
        invoke GetMenuItemCount,ebx
        mov esi,eax
        xor edi,edi
        inc edi
        .repeat
            invoke GetMenuState,ebx,edi,MF_BYPOSITION
            inc eax
            .if ! zero?
                dec eax
                test eax,MF_SEPARATOR
                .break .if ! zero?
            .endif
            inc edi
            dec esi
        .until zero?
        dec edi
        mov eax,lpData
        mov edx,MF_BYPOSITION or MF_STRING or MF_GRAYED or MF_UNCHECKED
        .if [eax].ADDINDATA.fProject != FALSE
            mov edx,MF_BYPOSITION or MF_STRING or MF_ENABLED or MF_UNCHECKED
        .endif
        invoke InsertMenu,ebx,edi,edx,IDAddIn,offset szMenuItem

        ; Messages to hook into
        mov eax,RAM_COMMAND or RAM_CLOSE or RAM_PROJECTOPENED or RAM_PROJECTCLOSED
    .endif

    ; ECX and EDX must be null before we return
    xor ecx,ecx
    xor edx,edx
    ret 

InstallDll Endp

align DWORD
DllProc         proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
; Export this proc (it is autoexported if MakeDef is enabled with option 2)
    ; This proc handles messages sent from RadASM to our dll
    ; Return TRUE to prevent RadASM and other DLL's from
    ; processing the message

    mov eax,uMsg
    .if eax == AIM_COMMAND
        mov eax,wParam
        .if eax == IDAddIn
            mov eax,lpData
;            mov edx,[eax].ADDINDATA.fProject
;            and edx,[eax].ADDINDATA.fResProject
;            .if edx != 0
            .if [eax].ADDINDATA.fProject != FALSE
                invoke FindResource,hInstance,IDD_DIALOG1,RT_DIALOG
                invoke LoadResource,hInstance,eax
                invoke LockResource,eax
                .if eax != 0
                    invoke DialogBoxIndirectParam,hMod,eax,hWin,offset DialogProc,0
                .endif
            .endif
        .endif
    .elseif eax == AIM_CLOSE
        mov eax,lpData
        invoke DeleteMenu,hSubMenu,IDAddIn,MF_BYCOMMAND
    .elseif eax == AIM_PROJECTOPENED
        invoke EnableMenuItem,hSubMenu,IDAddIn,MF_BYCOMMAND or MF_ENABLED
        test fOptions,16    ;Autorun on project open?
        .if ! zero?
            push lParam
            pop lpProject
            invoke LoadManifest
            invoke SaveManifest
            mov lpProject,0
        .endif
    .elseif eax == AIM_PROJECTCLOSED
        invoke EnableMenuItem,hSubMenu,IDAddIn,MF_BYCOMMAND or MF_GRAYED
        xor eax,eax
        mov lpProject,eax
        mov Manifest_Name,al
        mov Manifest_Ver,al
        mov Manifest_Desc,al
        mov Manifest_Company,al
        mov Manifest_Product,al
        mov Manifest_Internal,al
        mov Manifest_File,al
        mov Manifest_Path,al
        mov Manifest_RCfile,al
        mov Manifest_Tempfile,al
    .endif
    xor eax,eax
    ret
DllProc Endp

align DWORD
GetOptions      proc
; Export this proc (it is autoexported if MakeDef is enabled with option 2)
    
    mov eax,offset AddinOptions
    ret

GetOptions endp

;#########################################################################
;        AddManifest AddIn Procedures

align DWORD
MsgBox          proc pszText,pszCaption,dwFlags

    mov eax,hdlg
    .if eax == 0
        mov eax,lpHandles
        mov eax,[eax].ADDINHANDLES.hWnd
    .endif
    invoke MessageBox,eax,pszText,pszCaption,dwFlags
    ret

MsgBox          endp

align DWORD
DialogProc      proc hwnd,umsg,wparam,lparam
    
    mov eax,umsg
    .if eax == WM_COMMAND
        mov eax,wparam
        .if eax == IDCANCEL     ;Cancel
            invoke EndDialog,hwnd,eax
        .elseif eax == IDOK     ;Save
            invoke GetDlgItemText,hwnd,IDC_EDIT1,offset Manifest_Company,sizeof Manifest_Company
            invoke GetDlgItemText,hwnd,IDC_EDIT2,offset Manifest_Product,sizeof Manifest_Product
            invoke GetDlgItemText,hwnd,IDC_EDIT3,offset Manifest_Internal,sizeof Manifest_Internal
            invoke GetDlgItemText,hwnd,IDC_EDIT4,offset Manifest_Ver,sizeof Manifest_Ver
            invoke GetDlgItemText,hwnd,IDC_EDIT5,offset Manifest_Desc,sizeof Manifest_Desc
            invoke SaveManifest
            invoke EndDialog,hwnd,wparam
            mov hdlg,0
        .elseif eax == IDNO     ;Delete
            invoke DeleteManifest
            jmp @F
        .endif
    .elseif eax == WM_INITDIALOG
        push hwnd
        pop hdlg
@@:     invoke LoadManifest
        invoke SendDlgItemMessage,hwnd,IDC_EDIT1,EM_SETLIMITTEXT,sizeof Manifest_Company,0
        invoke SendDlgItemMessage,hwnd,IDC_EDIT2,EM_SETLIMITTEXT,sizeof Manifest_Product,0
        invoke SendDlgItemMessage,hwnd,IDC_EDIT3,EM_SETLIMITTEXT,sizeof Manifest_Internal,0
        invoke SendDlgItemMessage,hwnd,IDC_EDIT4,EM_SETLIMITTEXT,sizeof Manifest_Ver,0
        invoke SendDlgItemMessage,hwnd,IDC_EDIT5,EM_SETLIMITTEXT,sizeof Manifest_Desc,0
        invoke SetDlgItemText,hwnd,IDC_EDIT1,offset Manifest_Company
        invoke SetDlgItemText,hwnd,IDC_EDIT2,offset Manifest_Product
        invoke SetDlgItemText,hwnd,IDC_EDIT3,offset Manifest_Internal
        invoke SetDlgItemText,hwnd,IDC_EDIT4,offset Manifest_Ver
        invoke SetDlgItemText,hwnd,IDC_EDIT5,offset Manifest_Desc
    .endif
    xor eax,eax
    ret

DialogProc      endp

align DWORD
GetManifestFile proc uses edi
    ; Get manifest file name.

    local fDll  :dword
    local tempbuffer[MAX_PATH]:byte

    mov eax,lpData
    mov edi,[eax].ADDINDATA.lpProject
    .if edi == 0
        mov edi,lpProject
        test edi,edi
        jz @quit
    .endif
    invoke lstrlen,edi
    push eax
    add edi,eax
    mov ecx,eax
    mov al,'\'
    std
    repne scasb
    cld
    scasw
    pop edx
    neg ecx
    push edi
    add ecx,edx
    mov al,'.'
    repne scasb
    dec edi
    mov al,0
    stosb
    push offset Manifest_File
    call lstrcpy
    dec edi
    mov al,'.'
    stosb
    invoke lstrcat,offset Manifest_File,offset szDot
    mov eax,lpData
    invoke GetPrivateProfileString,offset szProject,offset szType,offset szNULL,addr tempbuffer,sizeof tempbuffer,[eax].ADDINDATA.lpProject
    invoke lstrcmpi,offset szDllProject,addr tempbuffer
    .if eax == 0
        mov eax,lpData
        invoke GetPrivateProfileString,offset szMakeFiles,offset sz7,offset szNULL,addr tempbuffer,sizeof tempbuffer,[eax].ADDINDATA.lpProject
        test eax,eax
        jz @F
        mov eax,dword ptr tempbuffer[eax - 4]
        or eax,20202000h
        .if eax == "lpc."
            push offset szCpl
            mov fDll,2
        .else
@@:         push offset szDll
            mov fDll,1
        .endif
    .else
        push offset szExe
        mov fDll,0
    .endif
    push offset Manifest_File
    call lstrcat
    invoke lstrcat,offset Manifest_File,offset szDot
    invoke lstrcat,offset Manifest_File,offset szManifest
    invoke lstrlen,offset Manifest_File
    neg eax
    add eax,sizeof Manifest_Path
    invoke lstrcpyn,offset Manifest_Path,[ebx].ADDINDATA.lpProjectPath,eax
    invoke lstrcat,offset Manifest_Path,offset Manifest_File
    mov eax,fDll
@quit:
    ret

GetManifestFile endp

align DWORD
ParseManifest   proc uses esi edi
    ; Parses the manifest data, to be exported to a file or the output window.
    ; The data is stored in a local memory object, that should be freed later.

    local dwver     :dword
    local dwname    :dword
    local dwdesc    :dword

    invoke lstrlen,offset Manifest_Ver
    mov dwver,eax
    invoke lstrlen,offset Manifest_Name
    mov dwname,eax
    invoke lstrlen,offset Manifest_Desc
    mov dwdesc,eax
    add eax,dwname
    add eax,dwver
    add eax,Manifest_Size1 + Manifest_Size2 + Manifest_Size3 + Manifest_Size4 + 1
    invoke LocalAlloc,LMEM_FIXED or LMEM_ZEROINIT,eax
    .if eax != 0
        push eax
        mov edi,eax
        mov esi,offset Manifest_Data1
        mov ecx,Manifest_Size1
        rep movsb
        mov esi,offset Manifest_Ver
        mov ecx,dwver
        rep movsb
        mov esi,offset Manifest_Data2
        mov ecx,Manifest_Size2
        rep movsb
        mov esi,offset Manifest_Name
        mov ecx,dwname
        rep movsb
        mov esi,offset Manifest_Data3
        mov ecx,Manifest_Size3
        rep movsb
        mov esi,offset Manifest_Desc
        mov ecx,dwdesc
        rep movsb
        mov esi,offset Manifest_Data4
        mov ecx,Manifest_Size4
        rep movsb
        mov al,0
        stosb
        pop eax
    .endif
    ret

ParseManifest   endp

align DWORD
LoadManifest    proc uses ebx
    ; Read data from RadAsm.ini and Project file.

    mov ebx,lpData
    mov eax,[ebx].ADDINDATA.lpProject
    .if eax != 0
        mov lpProject,eax
    .endif
    cmp lpProject,0
    je @F
    .if Manifest_Company == 0
        invoke GetPrivateProfileString,offset szManifest,offset szCompanyName,offset szNULL,offset Manifest_Company,sizeof Manifest_Company,[ebx].ADDINDATA.lpIniFile
        .if eax == 0
            invoke GetPrivateProfileString,offset szManifest,offset szCompanyName,offset szNULL,offset Manifest_Company,sizeof Manifest_Company,lpProject
            .if eax == 0
                invoke GetPrivateProfileString,offset szVerInf,offset szCompanyName,offset szNULL,offset Manifest_Company,sizeof Manifest_Company,lpProject
                .if eax == 0
                    invoke lstrcpy,offset Manifest_Company,offset szDefCompany
                .endif
            .endif
        .endif
    .endif
    .if Manifest_Product == 0
        invoke GetPrivateProfileString,offset szManifest,offset szProductName,offset szNULL,offset Manifest_Product,sizeof Manifest_Product,[ebx].ADDINDATA.lpIniFile
        .if eax == 0
            invoke GetPrivateProfileString,offset szManifest,offset szProductName,offset szNULL,offset Manifest_Product,sizeof Manifest_Product,lpProject
            .if eax == 0
                invoke GetPrivateProfileString,offset szVerInf,offset szProductName,offset szNULL,offset Manifest_Product,sizeof Manifest_Product,lpProject
                .if eax == 0
                    invoke lstrcpy,offset Manifest_Product,offset szDefProduct
                .endif
            .endif
        .endif
    .endif
    .if Manifest_Internal == 0
        invoke GetPrivateProfileString,offset szManifest,offset szInternalName,offset szNULL,offset Manifest_Internal,sizeof Manifest_Internal,[ebx].ADDINDATA.lpIniFile
        .if eax == 0
            invoke GetPrivateProfileString,offset szManifest,offset szInternalName,offset szNULL,offset Manifest_Internal,sizeof Manifest_Internal,lpProject
            .if eax == 0
                invoke GetPrivateProfileString,offset szVerInf,offset szInternalName,offset szNULL,offset Manifest_Internal,sizeof Manifest_Internal,lpProject
                .if eax == 0
                    invoke lstrcpy,offset Manifest_Internal,offset szDefInternal
                .endif
            .endif
        .endif
    .endif
    .if Manifest_Ver == 0
        invoke GetPrivateProfileString,offset szManifest,offset szProductVersion,offset szNULL,offset Manifest_Ver,sizeof Manifest_Ver,[ebx].ADDINDATA.lpIniFile
        .if eax == 0
            invoke GetPrivateProfileString,offset szManifest,offset szProductVersion,offset szNULL,offset Manifest_Ver,sizeof Manifest_Ver,lpProject
            .if eax == 0
                invoke GetPrivateProfileString,offset szVerInf,offset szProductVersion,offset szNULL,offset Manifest_Ver,sizeof Manifest_Ver,lpProject
                .if eax == 0
                    invoke lstrcpy,offset Manifest_Ver,offset szDefVer
                .endif
            .endif
        .endif
    .endif
    .if Manifest_Desc == 0
        invoke GetPrivateProfileString,offset szManifest,offset szFileDescription,offset szNULL,offset Manifest_Desc,sizeof Manifest_Desc,[ebx].ADDINDATA.lpIniFile
        .if eax == 0
            invoke GetPrivateProfileString,offset szManifest,offset szFileDescription,offset szNULL,offset Manifest_Desc,sizeof Manifest_Desc,lpProject
            .if eax == 0
                invoke GetPrivateProfileString,offset szVerInf,offset szFileDescription,offset szNULL,offset Manifest_Desc,sizeof Manifest_Desc,lpProject
                .if eax == 0
                    invoke GetPrivateProfileString,offset szProject,offset szDescription,offset szNULL,offset Manifest_Desc,sizeof Manifest_Desc,lpProject
                    .if eax == 0
                        invoke lstrcpy,offset Manifest_Desc,offset szDefDesc
                    .endif
                .endif
            .endif
        .endif
    .endif
@@: ret

LoadManifest    endp

align DWORD
SaveManifest    proc uses ebx esi edi
    ; Save manifest data to project file, and export it
    ;  to manifest file and/or resource script, depending
    ;  on the addin settings.

    local hfile     :dword
    local dwsize    :dword
    local pdata     :dword
    local dwbegin   :dword
    local pend      :dword
    local dwend     :dword
    local fDll      :dword
    local dummy     :dword
    local w32fd     :WIN32_FIND_DATA

    mov ebx,lpData
    mov eax,[ebx].ADDINDATA.lpProject
    .if eax != 0
        mov lpProject,eax
    .endif
    cmp lpProject,0
    je @quit

    ; Parse the name string from company, product and internal names.
    invoke lstrcpy,offset Manifest_Name,offset Manifest_Company
    invoke lstrcat,offset Manifest_Name,offset szDot
    invoke lstrcat,offset Manifest_Name,offset Manifest_Product
    invoke lstrcat,offset Manifest_Name,offset szDot
    invoke lstrcat,offset Manifest_Name,offset Manifest_Internal

    ; Save the data in the Project file
    invoke WritePrivateProfileString,offset szManifest,offset szCompanyName,offset Manifest_Company,lpProject
    invoke WritePrivateProfileString,offset szManifest,offset szProductName,offset Manifest_Product,lpProject
    invoke WritePrivateProfileString,offset szManifest,offset szInternalName,offset Manifest_Internal,lpProject
    invoke WritePrivateProfileString,offset szManifest,offset szProductVersion,offset Manifest_Ver,lpProject
    invoke WritePrivateProfileString,offset szManifest,offset szFileDescription,offset Manifest_Desc,lpProject

    test fOptions,2 + 4 ;No script or file?
    .if zero?           ;Then export to output window (always ASCII)
        invoke ParseManifest
        .if eax != 0
            mov edx,lpProc
            push eax
            .if edx != 0
                push eax
                call [edx].ADDINPROCS.lpTextOut
            .endif
            call LocalFree
        .endif
;        jmp @quit
    .endif

    invoke GetManifestFile
    mov fDll,eax
    test fOptions,4     ;Use manifest file?
    .if ! zero?
        ; Create manifest file
        mov hfile,0
        mov pdata,0
        mov Manifest_Tempfile,0
        invoke CreateFile,offset Manifest_Path,GENERIC_WRITE,FILE_SHARE_READ,0,CREATE_ALWAYS,FILE_FLAG_WRITE_THROUGH,0
        .if eax == 0
@werr2:     mov eax,offset szWriteError2
            jmp @error
        .endif
        mov hfile,eax
        invoke ParseManifest
        .if eax == 0
@@:         mov eax,offset szUnknownError
            jmp @error
        .endif
        mov pdata,eax
        mov edi,eax
        invoke lstrlen,eax
        xchg eax,ebx
        test fOptions,8 ;Use Unicode?
        .if ! zero?
            shl ebx,1
            invoke LocalAlloc,LMEM_FIXED or LMEM_ZEROINIT,ebx
            test eax,eax
            jz @B
            push eax
            invoke MultiByteToWideChar,CP_ACP,0,edi,-1,eax,ebx
            invoke LocalFree,edi
            pop edi
            mov pdata,edi
            dec ebx
        .endif
        dec ebx
        invoke SetLastError,0
        .repeat
            invoke WriteFile,hfile,edi,ebx,addr dummy,NULL
            .break .if eax == 0
            mov eax,dummy
            .break .if eax == 0
            add edi,eax
            sub ebx,eax
        .until zero?
        invoke GetLastError
        test eax,eax
        jnz @werr2
        invoke LocalFree,pdata
        invoke CloseHandle,hfile
;        ; Add manifest file to project
;        mov eax,lpProc
;        push FALSE
;        push TRUE
;        push offset Manifest_Path
;        call [eax].ADDINPROCS.lpAddProjectFile
    .else
        ; Delete manifest file (if found)
        invoke FindFirstFile,offset Manifest_Path,addr w32fd
        push eax
        invoke FindClose,eax
        pop eax
        inc eax
        .if ! zero?
            invoke GetPrivateProfileInt,offset szManifest,offset szDeleteFile,0,lpProject
            test eax,eax
            jnz @F
            invoke MsgBox,offset szDelFile,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
            .if eax != IDYES
                invoke WritePrivateProfileString,offset szManifest,offset szDeleteFile,offset sz1,lpProject
                jmp @F
            .endif
            invoke DeleteFile,offset Manifest_Path
@@:     
        .endif
    .endif

    mov ebx,lpData      ;Does this project have a resource script?
    .if [ebx].ADDINDATA.fResProject != FALSE
        mov hfile,0
        mov pdata,0
        mov Manifest_Tempfile,0
        invoke GetPrivateProfileString,offset szMakeFiles,offset sz1,offset szNULL,offset Manifest_RCfile,sizeof Manifest_RCfile,lpProject
        .if eax == 0
@unkerr:        mov eax,offset szUnknownError
            jmp @error
        .endif
        invoke CreateFile,offset Manifest_RCfile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_FLAG_RANDOM_ACCESS,0
        .if eax == 0
@readerr:       mov eax,offset szReadError
            jmp @error
        .endif
        mov hfile,eax
        invoke GetFileSize,eax,NULL
        mov dwsize,eax
        inc eax
        invoke LocalAlloc,LMEM_FIXED or LMEM_ZEROINIT,eax
        test eax,eax
        jz @unkerr
        mov pdata,eax
        mov esi,eax
        mov ebx,dwsize
        invoke SetLastError,0
        .if (esi != 0) && (ebx != 0)
            .repeat
                invoke ReadFile,hfile,esi,ebx,addr dummy,NULL
                .break .if eax == 0
                mov eax,dummy
                .break .if eax == 0
                add esi,eax
                sub ebx,eax
            .until zero?
        .endif
        invoke GetLastError
        test eax,eax
        jnz @readerr
        invoke lstrlen,pdata
        cmp eax,dwsize
        jne @readerr
        invoke InString,1,pdata,offset szRCSeparator
        test eax,eax
        .if (! zero?) && (! sign?)
            push offset szRCSeparator
            push pdata
            inc eax
            push eax
            dec eax
            dec eax
            mov dwbegin,eax
            call InString
            .if zero? || sign?
                invoke MsgBox,offset szTamper,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
                cmp eax,IDYES
                jne @errquit
                mov eax,dwsize
                inc eax
            .else
                add eax,sizeof szRCSeparator - 2
            .endif
            mov edx,dwsize
            sub edx,eax
            add eax,pdata
            mov pend,eax
            mov dwend,edx
        .else
            mov eax,dwsize
            mov dwbegin,eax
            mov pend,0
            mov dwend,0
        .endif
        test fOptions,2     ;Add to resource script?
        .if ! zero?
            invoke GetTempPath,sizeof Manifest_Tempfile - 12,offset Manifest_Tempfile
            invoke GetTempFileName,offset Manifest_Tempfile,offset szAMF,0,offset Manifest_Tempfile
            invoke CreateFile,offset Manifest_Tempfile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_FLAG_WRITE_THROUGH,0
            .if eax == 0
@writerr:       mov eax,offset szWriteError
                jmp @error
            .endif
            push eax
            invoke CloseHandle,hfile
            pop hfile
            mov esi,pdata
            mov ebx,dwbegin
            invoke SetLastError,0
            .if (esi != 0) && (ebx != 0)
                .repeat
                    invoke WriteFile,hfile,esi,ebx,addr dummy,NULL
                    .break .if eax == 0
                    mov eax,dummy
                    .break .if eax == 0
                    add esi,eax
                    sub ebx,eax
                .until zero?
            .endif
            invoke GetLastError
            test eax,eax
            jnz @writerr
            invoke WriteFile,hfile,offset szRCSeparator,sizeof szRCSeparator - 1,addr dummy,NULL
            test eax,eax
            jz @writerr
            lea edx,dummy
            push NULL
            push edx
            push 1
            mov eax,fDll
            .if eax == 0
                push offset sz1
            .elseif eax == 1
                push offset sz2
            .else
                push offset sz123
            .endif
            push hfile
            call WriteFile
            test fOptions,4
            .if zero?       ;Put all the manifest data in the script
                invoke WriteFile,hfile,offset Manifest_Add0,Manifest_AddSize0,addr dummy,NULL
                mov eax,offset Manifest_Add1
                mov edx,Manifest_AddSize1
                test fOptions,8 ;Use Unicode?
                .if zero?
                    inc eax
                    dec edx
                .endif
                lea ecx,dummy
                invoke WriteFile,hfile,eax,edx,ecx,NULL
                invoke lstrlen,offset Manifest_Ver
                lea edx,dummy
                invoke WriteFile,hfile,offset Manifest_Ver,eax,edx,NULL
                invoke WriteFile,hfile,offset Manifest_Add2,Manifest_AddSize2,addr dummy,NULL
                invoke lstrlen,offset Manifest_Name
                lea edx,dummy
                invoke WriteFile,hfile,offset Manifest_Name,eax,edx,NULL
                invoke WriteFile,hfile,offset Manifest_Add3,Manifest_AddSize3,addr dummy,NULL
                invoke lstrlen,offset Manifest_Desc
                lea edx,dummy
                invoke WriteFile,hfile,offset Manifest_Desc,eax,edx,NULL
                invoke WriteFile,hfile,offset Manifest_Add4,Manifest_AddSize4,addr dummy,NULL
            .else           ;Just include the manifest file in the script
                invoke WriteFile,hfile,offset Manifest_Include1,sizeof Manifest_Include1,addr dummy,NULL
                invoke lstrlen,offset Manifest_File
                lea edx,dummy
                invoke WriteFile,hfile,offset Manifest_File,eax,edx,NULL
                invoke WriteFile,hfile,offset Manifest_Include2,sizeof Manifest_Include2,addr dummy,NULL
            .endif
            invoke WriteFile,hfile,offset szRCSeparator,sizeof szRCSeparator - 1,addr dummy,NULL
            test eax,eax
            jz @writerr
        .else   ;Remove the inserted code if found
            invoke GetPrivateProfileInt,offset szManifest,offset szDeleteCode,0,lpProject
            test eax,eax
            jnz @errquit
            invoke MsgBox,offset szDelCode,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
            .if eax != IDYES
                invoke WritePrivateProfileString,offset szManifest,offset szDeleteCode,offset sz1,lpProject
                jmp @errquit
            .endif
            invoke GetTempPath,sizeof Manifest_Tempfile - 12,offset Manifest_Tempfile
            invoke GetTempFileName,offset Manifest_Tempfile,offset szAMF,0,offset Manifest_Tempfile
            invoke CreateFile,offset Manifest_Tempfile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_FLAG_WRITE_THROUGH,0
            .if eax == 0
@writerr3:          mov eax,offset szWriteError
                jmp @error
            .endif
            push eax
            invoke CloseHandle,hfile
            pop hfile
            mov esi,pdata
            mov ebx,dwbegin
            invoke SetLastError,0
            .if (esi != 0) && (ebx != 0)
                .repeat
                    invoke WriteFile,hfile,esi,ebx,addr dummy,NULL
                    .break .if eax == 0
                    mov eax,dummy
                    .break .if eax == 0
                    add esi,eax
                    sub ebx,eax
                .until zero?
            .endif
            invoke GetLastError
            test eax,eax
            jnz @writerr3
        .endif
        mov esi,pend
        mov ebx,dwend
        invoke SetLastError,0
        .if (esi != 0) && (ebx != 0)
            .repeat
                invoke WriteFile,hfile,esi,ebx,addr dummy,NULL
                .break .if eax == 0
                mov eax,dummy
                .break .if eax == 0
                add esi,eax
                sub ebx,eax
            .until zero?
        .endif
        invoke GetLastError
        test eax,eax
        jnz @writerr
        invoke LocalFree,pdata
        invoke CloseHandle,hfile
        invoke DeleteFile,offset Manifest_RCfile
        invoke MoveFile,offset Manifest_Tempfile,offset Manifest_RCfile
        .if eax == 0
            invoke MsgBox,offset szWriteError,offset szError,MB_OK or MB_ICONERROR
            jmp @quit
        .endif
        mov eax,lpData
        mov [eax].ADDINDATA.fResChanged,TRUE
    .endif

@quit:
    ret

@error:
    invoke MsgBox,eax,offset szError,MB_OK or MB_ICONERROR
@errquit:
    mov eax,pdata
    .if eax != 0
        invoke LocalFree,eax
    .endif
    mov eax,hfile
    .if eax != 0
        invoke CloseHandle,eax
    .endif
    .if Manifest_Tempfile != 0
        invoke DeleteFile,offset Manifest_Tempfile
    .endif
    jmp @quit

SaveManifest    endp

align DWORD
DeleteManifest  proc uses ebx esi edi
    ; Remove the manifest data from the project file,
    ;  delete the manifest file (if found),
    ;  and remove the inclusion from the resource script.

    local numbuffer[12]:byte
    local hfile     :dword
    local dwsize    :dword
    local pdata     :dword
    local dwbegin   :dword
    local pend      :dword
    local dwend     :dword
    local dummy     :dword
    local w32fd     :WIN32_FIND_DATA

    mov ebx,lpData
    mov eax,[ebx].ADDINDATA.lpProject
    .if eax != 0
        mov lpProject,eax
    .endif
    cmp lpProject,0
    je @quit

    ; Delete the manifest data from the project file.
    ; Removes the entire [Manifest] section. This may have to be changed in the future.
    invoke WritePrivateProfileString,offset szManifest,NULL,NULL,lpProject

    ; Get the manifest file name.
    invoke GetManifestFile

;    test fOptions,4     ;Use manifest file?
;    .if ! zero?
;        ; Remove manifest file from project.
;        xor esi,esi
;        xor edi,edi
;        mov ebx,lpProc
;        inc esi
;        .repeat
;            push esi
;            call [ebx].ADDINPROCS.lpGetFileNameFromID
;            .break .if eax == 0
;            invoke lstrcmpi,eax,offset Manifest_File
;            .if eax == 0
;                invoke dwtoa,esi,addr numbuffer
;                mov eax,lpData
;                invoke WritePrivateProfileString,offset szFiles,addr numbuffer,NULL,[eax].ADDINDATA.lpProject
;                ; TO DO: Fix the following entry numbers.
;                .break
;            .endif
;            inc esi
;        .until FALSE
;    .endif

    ; Delete the manifest file (if it exists).
    invoke FindFirstFile,offset Manifest_Path,addr w32fd
    push eax
    invoke FindClose,eax
    pop eax
    inc eax
    .if ! zero?
        test fOptions,4 ;Use manifest file?
        .if zero?
            mov eax,lpData
            invoke GetPrivateProfileInt,offset szManifest,offset szDeleteFile,0,lpProject
            test eax,eax
            jnz @F
            invoke MsgBox,offset szDelFile,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
            .if eax != IDYES
                invoke WritePrivateProfileString,offset szManifest,offset szDeleteFile,offset sz1,lpProject
                jmp @F
            .endif
        .endif
        invoke DeleteFile,offset Manifest_Path
@@: 
    .endif

    mov ebx,lpData      ;Does this project have a resource script?
    .if [ebx].ADDINDATA.fResProject != FALSE
        mov hfile,0
        mov pdata,0
        mov Manifest_Tempfile,0
        invoke GetPrivateProfileString,offset szMakeFiles,offset sz1,offset szNULL,offset Manifest_RCfile,sizeof Manifest_RCfile,lpProject
        .if eax == 0
@unkerr:    mov eax,offset szUnknownError
            jmp @error
        .endif
        invoke CreateFile,offset Manifest_RCfile,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_FLAG_RANDOM_ACCESS,0
        .if eax == 0
@readerr:   mov eax,offset szReadError
            jmp @error
        .endif
        mov hfile,eax
        invoke GetFileSize,eax,NULL
        mov dwsize,eax
        inc eax
        invoke LocalAlloc,LMEM_FIXED or LMEM_ZEROINIT,eax
        test eax,eax
        jz @unkerr
        mov pdata,eax
        mov esi,eax
        mov ebx,dwsize
        .repeat
            invoke ReadFile,hfile,esi,ebx,addr dummy,NULL
            .break .if eax == 0
            mov eax,dummy
            .break .if eax == 0
            add esi,eax
            sub ebx,eax
        .until zero?
        invoke lstrlen,pdata
        cmp eax,dwsize
        jne @readerr
        invoke InString,1,pdata,offset szRCSeparator
        test eax,eax
        .if (! zero?) && (! sign?)
            test fOptions,2     ;Add to resource script?
            .if zero?
                invoke GetPrivateProfileInt,offset szManifest,offset szDeleteCode,0,lpProject
                test eax,eax
                jnz @errquit
                invoke MsgBox,offset szDelCode,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
                .if eax != IDYES
                    invoke WritePrivateProfileString,offset szManifest,offset szDeleteCode,offset sz1,lpProject
                    jmp @errquit
                .endif
            .endif
            push offset szRCSeparator
            push pdata
            inc eax
            push eax
            dec eax
            dec eax
            mov dwbegin,eax
            call InString
            .if zero? || sign?
                invoke MsgBox,offset szTamper,offset szWarning,MB_YESNO or MB_DEFBUTTON2 or MB_ICONQUESTION
                cmp eax,IDYES
                jne @errquit
                mov eax,dwsize
                inc eax
            .else
                add eax,sizeof szRCSeparator - 2
            .endif
            mov edx,dwsize
            sub edx,eax
            add eax,pdata
            mov pend,eax
            mov dwend,edx
        .else
            mov eax,dwsize
            mov dwbegin,eax
            mov pend,0
            mov dwend,0
        .endif
        invoke GetTempPath,sizeof Manifest_Tempfile - 12,offset Manifest_Tempfile
        invoke GetTempFileName,offset Manifest_Tempfile,offset szAMF,0,offset Manifest_Tempfile
        invoke CreateFile,offset Manifest_Tempfile,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_FLAG_WRITE_THROUGH,0
        .if eax == 0
@writerr:       mov eax,offset szWriteError
            jmp @error
        .endif
        push eax
        invoke CloseHandle,hfile
        pop hfile
        mov esi,pdata
        mov ebx,dwbegin
        invoke SetLastError,0
        .if (esi != 0) && (ebx != 0)
            .repeat
                invoke WriteFile,hfile,esi,ebx,addr dummy,NULL
                .break .if eax == 0
                mov eax,dummy
                .break .if eax == 0
                add esi,eax
                sub ebx,eax
            .until zero?
        .endif
        invoke GetLastError
        test eax,eax
        jnz @writerr
        mov esi,pend
        mov ebx,dwend
        invoke SetLastError,0
        .if (esi != 0) && (ebx != 0)
            .repeat
                invoke WriteFile,hfile,esi,ebx,addr dummy,NULL
                .break .if eax == 0
                mov eax,dummy
                .break .if eax == 0
                add esi,eax
                sub ebx,eax
            .until zero?
        .endif
        invoke GetLastError
        test eax,eax
        jnz @writerr
        invoke LocalFree,pdata
        invoke CloseHandle,hfile
        invoke DeleteFile,offset Manifest_RCfile
        invoke MoveFile,offset Manifest_Tempfile,offset Manifest_RCfile
        .if eax == 0
            invoke MsgBox,offset szWriteError,offset szError,MB_OK or MB_ICONERROR
            jmp @quit
        .endif
        mov eax,lpData
        mov [eax].ADDINDATA.fResChanged,TRUE
    .endif

@quit:
    ret

@error:
    invoke MsgBox,eax,offset szError,MB_OK or MB_ICONERROR
@errquit:
    mov eax,pdata
    .if eax != 0
        invoke LocalFree,eax
    .endif
    mov eax,hfile
    .if eax != 0
        invoke CloseHandle,eax
    .endif
    .if Manifest_Tempfile != 0
        invoke DeleteFile,offset Manifest_Tempfile
    .endif
    jmp @quit

DeleteManifest  endp

End DllEntry
